import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.sql.*;
import java.util.*;

public class UpdateTable implements MouseListener, ActionListener 
{

	      	Connection conn=null;
		boolean fresh=true;
	      	ResultSet rs=null;
		String user;
		int noOfFields;
		int noOfRec;
		int id;
		String whereClause;
		
		JFrame frame;
		JPanel panel;
		JPanel buttonPanel;
		JScrollPane tablePanel;
		JTable table;

              	String[] fieldLabel;
		
		JButton queryButton,logoutButton,gAnalysisButton;


// constructor
public UpdateTable(String analysisUser,String analysisWhere,Connection dbConn)
	{
	user=new String(analysisUser);
	conn=dbConn;
	whereClause=new String(analysisWhere);
	buttonPanel=new JPanel(new FlowLayout());

	queryButton=new JButton("Query form");
	buttonPanel.add(queryButton);
	queryButton.addActionListener(this);

	gAnalysisButton=new JButton("Graphical analysis");
	buttonPanel.add(gAnalysisButton);
	gAnalysisButton.addActionListener(this);

	logoutButton=new JButton("Logout");
	buttonPanel.add(logoutButton);
	logoutButton.addActionListener(this);

	}



public void actionPerformed(ActionEvent e)
{
if("Query form".equals(e.getActionCommand()))
{
System.out.println("\nSo u want to submit query again");
AnalysisForm analysis=new AnalysisForm(user,conn);
frame.setVisible(false);
analysis.createAndShowGUI();
}
else if("Graphical analysis".equals(e.getActionCommand()))
{ 
System.out.println("\nshifting to graphical form");
frame.dispose();
MyGraphicAnalysis gra=new MyGraphicAnalysis(user,conn);
gra.createAndShowGUI();
}
else if("Logout".equals(e.getActionCommand()))
{
frame.dispose();
SwingApplication loginForm;
loginForm=new SwingApplication();
loginForm.createAndShowGUI();
}
}

public void createTable()
{
System.out.println("create table called");
        String query=new String("select count(*) from G24_T2");
        System.out.println("checing headings for table construction :"+query);
        try{
                PreparedStatement p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
                rs.next();
                noOfFields=Integer.parseInt(rs.getString(1));
                System.out.println("the query is executed...."+noOfFields);

                fieldLabel=new String[noOfFields+1];

                fieldLabel[0]=new String("Login");

                query="select * from G24_T2 order by id";
                p=conn.prepareStatement(query);
                rs=null;
                rs=p.executeQuery();
		System.out.println("now getting field names");
                int counter=0;
                while(rs.next())
                {
                fieldLabel[counter+1]=new String(rs.getString(2));
                counter++;
                }

		System.out.println("completed getting getting field names");
// my table
			
		System.out.println("now convertign where clause");
		whereClause=changeQuery(whereClause);
		System.out.println("completed converting and it is"+whereClause);
		query=new String("select count(*) from G24_T3 "+whereClause);
		System.out.println("creating table for query"+query);
                p=conn.prepareStatement(query);
		System.out.println("statement prepared");
                rs=null;
                rs=p.executeQuery();
		System.out.println("statement exe");
		rs.next();
		noOfRec=Integer.parseInt(rs.getString(1));
		if(noOfRec==0) 
		{
		JOptionPane.showMessageDialog(frame, "NO RECORDS");
		fresh=true;
		//show message 
		System.out.println("no records");
		}
		else
		{
		int rows=(noOfRec+1)/noOfFields;
		System.out.println("\ntotal no of recors:"+noOfRec+" fields "+noOfFields+"and rows in table:"+rows);
	        Object[][] data=new Object[rows][noOfFields+2];
  	        p=conn.prepareStatement("select * from G24_T3 "+whereClause);
		System.out.println("Into original creation "+whereClause);
                rs=null;
                rs=p.executeQuery();
		
		int row=0; 
		while(row<rows)
		{
		int count=1;
		System.out.println("Reading row no :"+row);
		while(count<=noOfFields)
		{
		rs.next();
		data[row][0]=rs.getString(1);
		System.out.println("data now inserted into table ["+row+"]["+count+"]="+rs.getString(3));
		data[row][count]=rs.getString(3);
		count++;
		}
		row++;
		}	
table = new JTable(data,fieldLabel);
table.addMouseListener(this);

System.out.println("completed creating table");
table.setPreferredScrollableViewportSize(new Dimension(500,200));

//Create the scroll pane and add the table to it.
tablePanel = new JScrollPane(table);

}//end of else
}catch(Exception ex){ System.out.println("Exception :"+ex); }
}


public void mouseClicked(MouseEvent e) {

String whereClause;
                int row = table.rowAtPoint(e.getPoint());
                int col = table.columnAtPoint(e.getPoint());
                String dataItem = (String)table.getValueAt(row,col);
                System.out.println("Selected row = " + row + "Selected Col = " + col);
		if(col==0)
		{
			UpdateUsers usr=new UpdateUsers(dataItem,conn);
			usr.createAndShowGUI();
			
		}
		else
		{
			int id=col;
			whereClause=new String("where id="+id+" and marks="+dataItem);
			//now creating new table for it
			System.out.println("Table is now Updated for query: "+whereClause);
			UpdateTable table=new UpdateTable(user,whereClause,conn);
			System.out.println("i will update table now......");
			table.createAndShowGUI();
			
		}
frame.dispose();
}

public String changeQuery(String query)
{
String s=new String("where user in ('0'");
try{
       PreparedStatement p=conn.prepareStatement("select user from G24_T3 "+query);
       rs=null;
       rs=p.executeQuery();
       	while(rs.next())
	{
	s+=",'"+rs.getString(1)+"'";
	}
	s+=") order by user";
   }catch(Exception ex){ System.out.println("exc"+ex); }
return s;
}
	


public void mousePressed(MouseEvent e) {}
public void mouseEntered(MouseEvent e) {}
public void mouseExited(MouseEvent e) {}
public void mouseReleased(MouseEvent e) {}




public void createAndShowGUI() {

	  System.out.println("now creating table form where clause");

	  JFrame.setDefaultLookAndFeelDecorated(true);
          frame = new JFrame("Analysis of user");
          frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
          
          frame.setSize(new Dimension(120, 120));
          this.createTable();		
	  JPanel p=new JPanel(new BorderLayout());
	  p.add(tablePanel, BorderLayout.NORTH);
	  p.add(buttonPanel,BorderLayout.CENTER);
	  frame.getContentPane().add(p, BorderLayout.CENTER);

          frame.pack();
          frame.setVisible(true);

  				}







}



